/* 
 * File:   mainWidget.cpp
 * Autor: Strelok Vlad Kolerts
 *
 * Created on Martch 16, 2009, 2:19 AM
 */
#include <qtimer.h>
#include "mainWidget.h"
#include "resources.h"

mainWidget::mainWidget() : ZKbMainWidget(ZHeader::FULL_TYPE, NULL, "ZMainWidget", WType_Modal | WType_TopLevel)//	TIME_TYPE,	TINY_TYPE,	SMALL_TYPE,	FULL_TYPE
{
	resize(240,320);
	a->installEventFilter(this);
    setMainWidgetTitle("kRepoz");
	fullScreenModeChanged(false);
	
	QFont font;
	font.setPixelSize(15);
	setFont(font);
	
	prog_dir=kGetPath(a->argv()[0]);
	
	w = new iWidget();

	QVBoxLayout* layout = getVBoxLayout();
	
	aia = new ZAppInfoArea(this,"",0);
	setTitleBarWidget(aia);
	
	font.setPixelSize(19);
	browser = new ZListBox(this, 0, ZSkinService::clsZListBox1);
	browser->setFixedWidth(240);
	browser->setItemFont(ZListBox::region2, font, true);
	browser->setItemFont(ZListBox::region2, font, false);
	
	ZScrollPanel* panel = new ZScrollPanel(this, "Widget", 0, (ZSkinService::WidgetClsID)4);
	//panel->setVScrollBarMode(ZScrollPanel::AlwaysOff);
    //panel->setHScrollBarMode(ZScrollPanel::AlwaysOff);
	//panel->setFixedWidth(240);
	panel->addChild(browser,0,0);
	layout->addWidget(panel);

	QPixmap pm;
	QRect rect;
	menu = new ZOptionsMenu(rect, NULL, NULL, 0);
	
	//pm->load(work_folder+IDB_IMAGE_PASTE);
	//menu->insertItem("\t\t\t"+LANG_PASTE, NULL, pm, false, 3, 3);
	menu->insertItem(UTF("Очистить кеш"), NULL, NULL, true, 0, 0);
	menu->insertItem(UTF("О программе"), NULL, NULL, true, 1, 1);
	menu->insertItem(UTF("Выход"), NULL, NULL, true, 2, 2);
	
	//menu->setItemEnabled(0, true);
	menu->connectItem(0, this, SLOT(slot_clearCache()));
	menu->connectItem(1, this, SLOT(slot_about()));
	menu->connectItem(2, this, SLOT(slot_quit()));
	
	softKey = new ZSoftKey(NULL, this, this);
	softKey->setText(ZSoftKey::LEFT, UTF("Опции"), (ZSoftKey::TEXT_PRIORITY) 0);
	softKey->setText(ZSoftKey::RIGHT, UTF("Выход"), (ZSoftKey::TEXT_PRIORITY) 0);
	softKey->setOptMenu(ZSoftKey::LEFT, menu);
	softKey->setClickedSlot(ZSoftKey::RIGHT, this, SLOT(slot_quit()));
    setSoftKey(softKey);
	
	connect(browser, SIGNAL(selected(int)), this, SLOT(selected(int)));
	
	setServer();
}

mainWidget::~mainWidget()
{
}

void mainWidget::setServer()
{
	servSet=true;
	browser->clear();
	path_aia=UTF("Выберите сервер");

	aia->removeArea(ZAppInfoArea::ACTIVITY);
	aia->appendText(ZAppInfoArea::ACTIVITY, path_aia, "path");

	QString line;
	QStringList servers;
	QFile f(prog_dir+"server.ini");
	if ( f.open( IO_ReadOnly ) ) 
	{
		QTextStream stream(&f);
		while(line=stream.readLine())
		{
			if(line!="" && line!=" ")
			servers.append(line);
		}
		f.close();
	}

	QPixmap pm;
	if(servers.count()>0)
	{
		for(int i=0; i<(int)servers.count(); i++)
		{
			ZListBoxItem* Item = new ZListBoxItem ( browser, "%I%M" );
			pm.load(prog_dir+IDB_IMAGE_HTTP);
			if(servers[i].left(6)=="ftp://")
				pm.load(prog_dir+IDB_IMAGE_FTP);
			Item->setPixmap(0, pm);
			Item->appendSubItem(1, servers[i], false, NULL);			
			browser->insertItem(Item,-1,true);
		}
	}
	else
		showNotyfi("Список серверов пуст", IDB_IMAGE_ERROR, 0);
}

void mainWidget::setDir(QString p)
{
	servSet=false;
	dat.clear();
	browser->clear();

	path=p;
	path_aia=server+path;
	qDebug("SetDir "+path_aia);
	int j = aia->getWidth(ZAppInfoArea::ACTIVITY);
	int i = fontMetrics().width(path_aia);
	if(!j)
		j=228;
	while (j < i)
	{
		path_aia.remove(0, 1);
		path_aia.replace(0, 3, "...");
		i = fontMetrics().width(path_aia);
	}
	showNotyfi("Получение списка пакетов", IDB_OPEN_WITH, 0);
	/*aia->removeArea(ZAppInfoArea::ACTIVITY);
	aia->appendText(ZAppInfoArea::ACTIVITY, path_aia, "path");
	a->processEvents();*/
	
	QPixmap pm;
	ZListBoxItem* Item = new ZListBoxItem(browser, "%I%M");
	pm.load(prog_dir+IDB_IMAGE_BACK);
	a->processEvents();
	Item->setPixmap(0, pm);
	Item->appendSubItem(1, "..", false, NULL);
	browser->insertItem(Item,-1,true);
	
	if(!fExist(prog_dir+"cache/"+path+"/list"))
	{
		QDir dir;
		dir.setPath(prog_dir+"cache");
		dir.mkdir(path, false);
		system(QString("/bin/busybox wget -O %1 %2").arg(prog_dir+"cache/"+path+"/list").arg(server+path+"/E2"));
	}
	if(fExist(prog_dir+"cache/"+path+"/list"))
	{
		QString line;
		QFile f(prog_dir+"cache/"+path+"/list");
		if ( f.open( IO_ReadOnly ) ) 
		{
			QTextStream stream(&f);
			while(line=stream.readLine())
			{
				if(line.right(1)==" ")
					line.remove(line.length()-1,1);
				dat.append(line);
			}
			f.close();
		}
		
		for(int i=0; i<(int)dat.count(); i++)
		{
			ZListBoxItem* Item = new ZListBoxItem ( browser, "%I%M" );
			if(dat[i].left(1)=="/")
				pm.load(prog_dir+IDB_IMAGE_DIR);
			else
				pm.load(prog_dir+IDB_IMAGE_FILE);
			
			Item->setPixmap(0, pm);
			Item->appendSubItem(1, dat[i], false, NULL);			
			browser->insertItem(Item,-1,true);
		}
		showNotyfi("Операция завершена успешно", IDB_IMAGE_WARNING, 1500);
	}
	else
		showNotyfi("Ошибка получения списка", IDB_IMAGE_ERROR, 2000);
}

void mainWidget::upDir()
{
	if(path!="")
	{
		int pos=path.findRev("/");
		if(pos==-1)
			path="";
		else
			path=path.left(pos-1);
	
		setDir(path);
	}
	else
		setServer();
}

void mainWidget::selected(int index)
{
	ZListBoxItem* listitem = browser->item(index);
	QString name=listitem->getSubItemText ( 1, 0, false );
	if(servSet)
	{
		if(server!=name+"/")
		{
			slot_clearCache();
			server=name+"/";
		}
		setDir("");
	}
	else
	{
		if(name=="..")
			upDir();
		else
		{
			if(name.left(1)=="/")
			{
				name.remove(0,1);
				setDir(path+name);
			}
			else
			{
				showNotyfi("Получение информации о пакете", IDB_OPEN_WITH, 0);
				QDir dir;
				dir.setPath(prog_dir+"cache/"+path);
				dir.mkdir(name, false);
				
				QString p=path+"/"+name+"/info";
				if(!fExist(prog_dir+"cache/"+p))
					system(QString("/bin/busybox wget -O %1 %2").arg(prog_dir+"cache/"+p).arg(server+p));
				
				showNotyfi("Операция завершена успешно", IDB_IMAGE_WARNING, 0);
				
				if(fExist(prog_dir+"cache/"+p))
				{
					p=info(prog_dir+"cache/"+p);
					if(p!="")
					{
						p=path+"/"+name+"/"+p;
						system(QString("/bin/busybox wget -O %1 %2").arg(prog_dir+"cache/"+p).arg(server+p));
						if(fExist(prog_dir+"cache/"+p))
						{
							showNotyfi("Запуск установки пакета", IDB_IMAGE_WARNING, 2000);
							system(QString("/mmc/mmca1/.system/FsMan/plugins/Installer/Installer -d %1").arg(prog_dir+"cache/"+p));
						}
						else
							showNotyfi("Ошибка получения пакета", IDB_IMAGE_ERROR, 2000);
					}
				}
				else
					showNotyfi("Ошибка получения информации", IDB_IMAGE_ERROR, 2000);
			}
		}
	}
}

QString mainWidget::info(QString path)
{
	QString	text, size, lng, ver, line, pkg;
	QFile f(path);
	if (f.open(IO_ReadOnly)) 
	{
		QTextStream stream(&f);
		while(line=stream.readLine())
		{
			if(line.find("info")==0 && text=="")
			{
				line.remove(0,7);
				text="<b>Описание</b>:<br/>"+line+"<hr/>";
			}
			else if(line.find("info.ru")==0)
			{
				line.remove(0,10);
				text="<b>Описание</b>:<br/>"+line+"<hr/>";
			}
			else if(line.find("version")==0)
			{
				line.remove(0,10);
				ver="<b>Версия</b>: "+line+"<br/>";
			}
			else if(line.find("size")==0)
			{
				line.remove(0,7);
				size="<b>Размер</b>: "+line+"<br/>";
			}
			else if(line.find("lng")==0)
			{
				line.remove(0,6);
				lng="<b>Язык</b>: "+line+"<hr/>";
			}
			else if(line.find("E2")==0)
			{
				line.remove(0,5);
				pkg=line;
			}
		}
		f.close();
	}
	w->Label->setFont(QFont("KolertsFont",13,25,false));
	w->Label->setText(UTF(text+size+ver+lng+"<b>Загрузить и установить сейчас?</b>"));
	w->Label->setAlignment(Qt::AlignTop|Qt::AlignLeft);
	if(w->Show(1))
	{
		showNotyfi("Получение пакета..", IDB_OPEN_WITH, 0);
		return pkg;
	}
	else
	{
		showNotyfi("Скачивание отменено", IDB_IMAGE_WARNING, 1000);
		return "";
	}
}

void mainWidget::slot_clearCache()
{
	showNotyfi("Очистка кешированных файлов", IDB_OPEN_WITH, 0);
	system(QString("rm -f -R %1").arg(prog_dir+"cache"));
	QDir dir;
	dir.setPath(prog_dir);
	dir.mkdir("cache", false);
	setServer();
}

void mainWidget::slot_about()
{
	QString	text="<p>Благодаря данному приложению вы сможете скачивать и устанавливать приложения с http ftp серверов, предварительно просмотрев информацию о них</p>";
	
	w->Label->setFont(QFont("KolertsFont",17,25,false));
	w->Label->setText(UTF(text));
	w->Label->setAlignment(Qt::AlignCenter);
	w->Show(0);
	/*delete w;
	w = NULL;*/
}

void mainWidget::slot_infoArea()
{
	aia->removeArea(ZAppInfoArea::ACTIVITY);
	aia->appendText(ZAppInfoArea::ACTIVITY, path_aia, "path");
}

void mainWidget::slot_quit()
{
	a->quit();
}

void mainWidget::showNotyfi(QString text, QString pm, int time)
{
	aia->removeArea(ZAppInfoArea::ACTIVITY);
	if(pm!="")
		aia->appendIcon(ZAppInfoArea::ACTIVITY, QPixmap(prog_dir+pm), "");
	aia->appendText(ZAppInfoArea::ACTIVITY, UTF(text), "");
	a->processEvents();
	if(time)
		QTimer::singleShot(time, this, SLOT(slot_infoArea()));
}
/// --------------------------------------------------------

bool mainWidget::fExist(const QString &fpath)
{
    QFileInfo f(fpath);
    if (f.exists())
        return true;
    else
        return false;
}

void mainWidget::keyPressEvent ( QKeyEvent* k )	//keyReleaseEvent
{
	switch(k->key())
	{
		case 4146:
			upDir();
		break;
	}
}

/*void mainWidget::keyReleaseEvent ( QKeyEvent* k )	//keyReleaseEvent
	{
	}*/
