/* 
 * File:   mainWidget.h
 * Author: Strelok Vlad Kolerts 2010
 */

#ifndef _MAINWIDGET_H
#define	_MAINWIDGET_H

#include <ZOptionsMenu.h>
#include <ZAppInfoArea.h>
#include <ZListBox.h>
#include "iWidget.h"
#include <qdir.h>
#include <qfile.h>
#include <qtextstream.h>

class mainWidget: public ZKbMainWidget
{
    Q_OBJECT
public:
    mainWidget();
    ~mainWidget();
	
	iWidget* w;
	
	ZListBox*		browser;
	ZAppInfoArea*	aia;
    ZOptionsMenu*	menu;
	ZSoftKey*		softKey;
	
	QStringList		dat;
	QString prog_dir, server, path, path_aia;
	bool servSet;

	void setServer();
	void setDir(QString p);
	void upDir();
	QString info(QString path);
	void showNotyfi(QString text, QString pm, int time);
	bool fExist(const QString &fpath);
	int curItem();

public slots:
	void selected(int);
	void slot_clearCache();
	void slot_about();
	void slot_infoArea();
	void slot_quit();

protected:
    virtual void keyPressEvent(QKeyEvent* k);
	//virtual void keyReleaseEvent(QKeyEvent* k);
};


#endif	/* _mainWidget_H */
